/*
  libwftk - Worldforge Toolkit - a widget library
  Copyright (C) 2002 Malcolm Walker <malcolm@worldforge.org>
  Based on code copyright  (C) 1999-2002  Karsten Laux 

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.
  
  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA  02111-1307, SA.
*/


#ifndef _STRING_HASH_MAP_H
#define _STRING_HASH_MAP_H

#if __GNUC__ > 2 
#include <ext/hash_map>
#else
#include <hash_map>
#endif
#include <string>

namespace wftk {

/// A wrapper for std::hash_map<std::string,Foo>, since it didn't make the C++ standard
template<class C>
struct StringHash
{
  /// call the string hashing function
  size_t operator () (const std::string& s) const {return hash_(s.c_str());}

  /// A hash_map<std::string, C>
  typedef typename __gnu_cxx::hash_map<std::string, C, StringHash> Map;

 private:
  __gnu_cxx::hash<const char*> hash_;
};

} // namespace

#endif
