/*
  libwftk - Worldforge Toolkit - a widget library
  Copyright (C) 2002 Malcolm Walker <malcolm@worldforge.org>
  Based on code copyright  (C) 1999-2002  Karsten Laux 

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.
  
  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA  02111-1307, USA.
*/
// written by Karsten Laux, November 1999  

#ifndef _WVERSION_H_
#define _WVERSION_H_

#define WFTK_MAJOR_VERSION       0
#define WFTK_MINOR_VERSION       7
#define WFTK_PATCHLEVEL          1     

// WFTK_DISABLE_DEPRECATED get rid of stupid 'extern C',
// also return a reference instead of a pointer

#ifdef __cplusplus
extern "C" {
#endif  

/**
 * Structure containing the current version of wftk.
 */
typedef struct {
	/// major version number
	unsigned char major;
	/// minor version number
	unsigned char minor;
	/// patch version number
	unsigned char patch;
} wftk_version;

const wftk_version* getVersion();

#ifdef __cplusplus
}
#endif

#endif
