/*
  libwftk - Worldforge Toolkit - a widget library
  Copyright (C) 2003 Ron Steinke <rsteinke@w-link.net>

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA  02111-1307, SA.
*/

#ifndef _VIDEO_WIDGET_H
#define _VIDEO_WIDGET_H

#include <wftk/screenarea.h>
#include <wftk/video.h>

namespace wftk {

/// Video player widget
class VideoWidget : public ScreenArea, public Video
{
 public:
  /// Contstruct with given origin (top-left) and dimensions
  explicit VideoWidget();

  /// load the video
  virtual bool load(const std::string& filename, double scale = 1);
 
 protected: 

  // Make it opaque
  virtual void handleResize(Uint16 w, Uint16 h);
  ///
  virtual void setPackingInfo();

 private:

  /// updates the Video draw mask
  virtual void updateExposeMask() {Video::setMask(ScreenArea::getExposed());}
};

} // namespace wftk

#endif // _VIDEO_WIDGET_H
